diff -ur snort-2.0.2/src/output-plugins/spo_alert_fast.h snort-2.0.2-ipv6/src/output-plugins/spo_alert_fast.h
--- snort-2.0.2/src/output-plugins/spo_alert_fast.h	Mon Apr  1 12:08:24 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_fast.h	Tue Sep 30 13:25:26 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_fast.h,v 1.6 2002/04/01 03:08:24 andrewbaker Exp $ */
+/* $Id: spo_alert_fast.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* This file gets included in plugbase.h when it is integrated into the rest 
  * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
diff -ur snort-2.0.2/src/output-plugins/spo_alert_full.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_full.c
--- snort-2.0.2/src/output-plugins/spo_alert_full.c	Tue May 20 03:08:04 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_full.c	Tue Nov 11 12:02:59 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_full.c,v 1.17 2003/05/19 18:08:04 chrisgreen Exp $ */
+/* $Id: spo_alert_full.c,v 1.2 2003/11/11 03:02:59 abekatsu Exp $ */
 
 /* spo_alert_full
  * 
@@ -153,7 +153,7 @@
         fwrite("[**] Snort Alert! [**]\n", 23, 1, data->file);
     }
 
-    if(p && p->iph)
+    if(p && (p->iph || p->ip6h))
     {
         PrintPriorityData(data->file, 1);
     }
@@ -174,7 +174,8 @@
             Print2ndHeader(data->file, p);
         }
 
-        PrintIPHeader(data->file, p);
+	if (p->iph) 
+	     PrintIPHeader(data->file, p);
 
         /* if this isn't a fragment, print the other header info */
         if(!p->frag_flag)
@@ -193,6 +194,10 @@
                     PrintICMPHeader(data->file, p);
                     break;
 
+	        case IPPROTO_ICMPV6:
+                    PrintICMP6Header(data->file, p);
+                    break;
+
                 default:
                     break;
             }
@@ -202,6 +207,44 @@
 
         fputc('\n', data->file);
     } /* End of if(p) */
+    else if (p && p->ip6h)
+    {
+        /* print the packet header to the alert file */
+
+        if(pv.show2hdr_flag)
+        {
+            Print2ndHeader(data->file, p);
+        }
+
+	if (p->ip6h) 
+	     PrintIP6Header(data->file, p);
+
+        /* if this isn't a fragment, print the other header info */
+        if(!p->frag_flag)
+        {
+            switch(p->ip6h->s_ip6_nxt)
+            {
+                case IPPROTO_TCP:
+                    PrintTCPHeader(data->file, p);
+                    break;
+
+                case IPPROTO_UDP:
+                    PrintUDPHeader(data->file, p);
+                    break;
+
+	        case IPPROTO_ICMPV6:
+                    PrintICMP6Header(data->file, p);
+                    break;
+
+                default:
+                    break;
+            }
+
+            PrintXrefs(data->file, 1);
+        }
+
+        fputc('\n', data->file);
+    }
     else
     {
         fputs("\n\n", data->file);
diff -ur snort-2.0.2/src/output-plugins/spo_alert_full.h snort-2.0.2-ipv6/src/output-plugins/spo_alert_full.h
--- snort-2.0.2/src/output-plugins/spo_alert_full.h	Mon Apr  1 12:08:24 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_full.h	Tue Sep 30 13:25:26 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_full.h,v 1.7 2002/04/01 03:08:24 andrewbaker Exp $ */
+/* $Id: spo_alert_full.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* This file gets included in plugbase.h when it is integrated into the rest 
  * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
diff -ur snort-2.0.2/src/output-plugins/spo_alert_sf_socket.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_sf_socket.c
--- snort-2.0.2/src/output-plugins/spo_alert_sf_socket.c	Wed May 28 06:19:54 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_sf_socket.c	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_sf_socket.c,v 1.3 2003/05/27 21:19:54 chrisgreen Exp $ */
+/* $Id: spo_alert_sf_socket.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 #ifndef WIN32
 /* Win32 doesn't support AF_UNIX sockets, so let's not go there... */
diff -ur snort-2.0.2/src/output-plugins/spo_alert_smb.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_smb.c
--- snort-2.0.2/src/output-plugins/spo_alert_smb.c	Tue May 20 03:08:04 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_smb.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spo_alert_smb.c,v 1.27 2003/05/19 18:08:04 chrisgreen Exp $ */
+/* $Id: spo_alert_smb.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2000,2001 Andrew R. Baker <andrewb@uab.edu>
diff -ur snort-2.0.2/src/output-plugins/spo_alert_smb.h snort-2.0.2-ipv6/src/output-plugins/spo_alert_smb.h
--- snort-2.0.2/src/output-plugins/spo_alert_smb.h	Fri Mar 14 17:28:53 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_smb.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spo_alert_smb.h,v 1.7 2003/03/14 08:28:53 chris_reid Exp $ */
+/* $Id: spo_alert_smb.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2000,2001 Andrew R. Baker <andrewb@uab.edu>
diff -ur snort-2.0.2/src/output-plugins/spo_alert_syslog.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_syslog.c
--- snort-2.0.2/src/output-plugins/spo_alert_syslog.c	Tue May 20 03:08:04 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_syslog.c	Tue Sep 30 13:25:26 2003
@@ -15,7 +15,7 @@
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
-/* $Id: spo_alert_syslog.c,v 1.35 2003/05/19 18:08:04 chrisgreen Exp $ */
+/* $Id: spo_alert_syslog.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* spo_alert_syslog 
  * 
diff -ur snort-2.0.2/src/output-plugins/spo_alert_syslog.h snort-2.0.2-ipv6/src/output-plugins/spo_alert_syslog.h
--- snort-2.0.2/src/output-plugins/spo_alert_syslog.h	Mon Apr  1 05:42:19 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_syslog.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_syslog.h,v 1.5 2002/03/31 20:42:19 andrewbaker Exp $ */
+/* $Id: spo_alert_syslog.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* This file gets included in plugbase.h when it is integrated into the rest 
  * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
diff -ur snort-2.0.2/src/output-plugins/spo_alert_unixsock.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_unixsock.c
--- snort-2.0.2/src/output-plugins/spo_alert_unixsock.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_unixsock.c	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spo_alert_unixsock.c,v 1.24 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_alert_unixsock.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2000,2001 Andrew R. Baker <andrewb@uab.edu>
diff -ur snort-2.0.2/src/output-plugins/spo_alert_unixsock.h snort-2.0.2-ipv6/src/output-plugins/spo_alert_unixsock.h
--- snort-2.0.2/src/output-plugins/spo_alert_unixsock.h	Wed Apr  2 06:31:58 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_unixsock.h	Tue Sep 30 13:25:26 2003
@@ -1,4 +1,4 @@
-/* $Id: spo_alert_unixsock.h,v 1.8 2003/04/01 21:31:58 chrisgreen Exp $ */
+/* $Id: spo_alert_unixsock.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2000,2001 Andrew R. Baker <andrewb@uab.edu>
diff -ur snort-2.0.2/src/output-plugins/spo_csv.c snort-2.0.2-ipv6/src/output-plugins/spo_csv.c
--- snort-2.0.2/src/output-plugins/spo_csv.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_csv.c	Tue Sep 30 13:25:26 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_csv.c,v 1.19 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_csv.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* spo_csv
  * 
diff -ur snort-2.0.2/src/output-plugins/spo_csv.h snort-2.0.2-ipv6/src/output-plugins/spo_csv.h
--- snort-2.0.2/src/output-plugins/spo_csv.h	Wed Apr  3 07:50:59 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_csv.h	Tue Sep 30 13:25:26 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_csv.h,v 1.7 2002/04/02 22:50:59 andrewbaker Exp $ */
+/* $Id: spo_csv.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* This file gets included in plugbase.h when it is integrated into the rest 
  * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
diff -ur snort-2.0.2/src/output-plugins/spo_database.c snort-2.0.2-ipv6/src/output-plugins/spo_database.c
--- snort-2.0.2/src/output-plugins/spo_database.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_database.c	Fri Dec 12 20:39:59 2003
@@ -18,7 +18,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_database.c,v 1.70 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_database.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* Snort Database Output Plug-in
  * 
@@ -51,6 +51,10 @@
 #endif
 
 #include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
 #include <stdlib.h>
 #include <string.h>
 
@@ -66,6 +70,7 @@
 #include "snort.h"
 
 #ifdef ENABLE_POSTGRESQL
+    #include <pg_config.h>
     #include <libpq-fe.h>
 #endif
 #ifdef ENABLE_MYSQL
@@ -1245,7 +1250,135 @@
                             ntohs(p->udph->uh_dport));
                 }
             }
-        }   
+        }
+	else if ((!p->frag_flag) && (p->ip6h != NULL))
+	{
+	    if (p->ip6h->s_ip6_nxt == IPPROTO_ICMPV6 && p->icmp6h)  
+	    {
+		query = NewQueryNode(query, 0);
+                /*** Build a query for the ICMPv6 Header ***/
+                if(data->detail)
+		{
+		     if(p->ext)
+		     {
+			 /*
+			 snprintf(query->val, MAX_QUERY_LENGTH, 
+				 "INSERT INTO icmp6hdr (sid, cid, icmp6_type, icmp6_code, "
+				 "icmp6_cksum, icmp6_id, icmp6_seq) "
+				 "VALUES ('%u','%u','%u','%u','%u','%u','%u')",
+                                data->shared->sid, data->shared->cid, 
+				p->icmp6h->icmp6_type, p->icmp6h->icmp6_code,
+				ntohs(p->icmp6h->icmp6_cksum), 
+				ntohs(p->ext->id), ntohs(p->ext->seqno));			 
+			 */
+
+			 snprintf(query->val, MAX_QUERY_LENGTH, 
+				 "INSERT INTO icmp6hdr (sid, cid, icmp6_type, icmp6_code, "
+				 "icmp6_cksum) "
+				 "VALUES ('%u','%u','%u','%u','%u')",
+				 data->shared->sid, data->shared->cid, 
+				 p->icmp6h->icmp6_type, p->icmp6h->icmp6_code,
+				 ntohs(p->icmp6h->icmp6_cksum));
+
+		     }
+		     else
+		     {
+			 snprintf(query->val, MAX_QUERY_LENGTH, 
+				 "INSERT INTO icmp6hdr (sid, cid, icmp6_type, icmp6_code, "
+				 "icmp6_cksum) "
+				 "VALUES ('%u','%u','%u','%u','%u')",
+				 data->shared->sid, data->shared->cid, p->icmp6h->icmp6_type, p->icmp6h->icmp6_code,
+				 ntohs(p->icmp6h->icmp6_cksum));
+		     }
+		}
+		else
+		{
+		    snprintf(query->val, MAX_QUERY_LENGTH, 
+			    "INSERT INTO icmp6hdr (sid, cid, icmp6_type, icmp6_code) "
+			    "VALUES ('%u','%u','%u','%u')",
+			    data->shared->sid, data->shared->cid, p->icmp6h->icmp6_type, p->icmp6h->icmp6_code);
+		}
+	    }
+            else if(p->ip6h->s_ip6_nxt == IPPROTO_TCP && p->tcph)
+            {
+                query = NewQueryNode(query, 0);
+                /*** Build a query for the TCP Header ***/
+                if(data->detail)
+                {
+                    snprintf(query->val, MAX_QUERY_LENGTH, 
+                            "INSERT INTO tcphdr "
+                            "(sid, cid, tcp_sport, tcp_dport, tcp_seq,"
+                            " tcp_ack, tcp_off, tcp_res, tcp_flags, tcp_win,"
+                            " tcp_csum, tcp_urp) "
+                            "VALUES ('%u','%u','%u','%u','%lu','%lu','%u',"
+                            "'%u','%u','%u','%u','%u')",
+                            data->shared->sid, data->shared->cid, ntohs(p->tcph->th_sport), 
+                            ntohs(p->tcph->th_dport), (u_long)ntohl(p->tcph->th_seq),
+                            (u_long)ntohl(p->tcph->th_ack), TCP_OFFSET(p->tcph), 
+                            TCP_X2(p->tcph), p->tcph->th_flags, 
+                            ntohs(p->tcph->th_win), ntohs(p->tcph->th_sum),
+                            ntohs(p->tcph->th_urp));
+                }
+                else
+                {
+                    snprintf(query->val, MAX_QUERY_LENGTH, 
+                            "INSERT INTO tcphdr "
+                            "(sid,cid,tcp_sport,tcp_dport,tcp_flags) "
+                            "VALUES ('%u','%u','%u','%u','%u')",
+                            data->shared->sid, data->shared->cid, ntohs(p->tcph->th_sport), 
+                            ntohs(p->tcph->th_dport), p->tcph->th_flags);
+                }
+
+
+                if(data->detail)
+                {
+                    /*** Build the query for TCP Options ***/
+                    for(i=0; i < (int)(p->tcp_option_count); i++)
+                    {
+                        query = NewQueryNode(query, 0);
+                        if((data->encoding == ENCODING_HEX) || (data->encoding == ENCODING_ASCII))
+                        {
+                            tmp = fasthex(p->tcp_options[i].data, p->tcp_options[i].len); 
+                        }
+                        else
+                        {
+                            tmp = base64(p->tcp_options[i].data, p->tcp_options[i].len);
+                        }
+                        snprintf(query->val, MAX_QUERY_LENGTH, 
+                                "INSERT INTO opt "
+                                "(sid,cid,optid,opt_proto,opt_code,opt_len,opt_data) "
+                                "VALUES ('%u','%u','%u','%u','%u','%u','%s')",
+                                data->shared->sid, data->shared->cid, i, 6, p->tcp_options[i].code,
+                                p->tcp_options[i].len, tmp); 
+                        free(tmp);
+                    }
+                }
+            }
+            else if(p->ip6h->s_ip6_nxt == IPPROTO_UDP && p->udph)
+            {
+                query = NewQueryNode(query, 0);
+                /*** Build the query for the UDP Header ***/
+                if(data->detail)
+                {
+                    snprintf(query->val, MAX_QUERY_LENGTH,
+                            "INSERT INTO udphdr "
+                            "(sid, cid, udp_sport, udp_dport, udp_len, udp_csum) "
+                            "VALUES ('%u', '%u', '%u', '%u', '%u', '%u')",
+                            data->shared->sid, data->shared->cid, ntohs(p->udph->uh_sport), 
+                            ntohs(p->udph->uh_dport), ntohs(p->udph->uh_len),
+                            ntohs(p->udph->uh_chk));
+                }
+                else
+                {
+                    snprintf(query->val, MAX_QUERY_LENGTH,
+                            "INSERT INTO udphdr "
+                            "(sid, cid, udp_sport, udp_dport) "
+                            "VALUES ('%u', '%u', '%u', '%u')",
+                            data->shared->sid, data->shared->cid, ntohs(p->udph->uh_sport), 
+                            ntohs(p->udph->uh_dport));
+                }
+	    }
+	}
 
         /*** Build the query for the IP Header ***/
         if ( p->iph )
@@ -1305,6 +1438,44 @@
                 }
             }
         }
+
+        /*** Build the query for the IPv6 Header ***/
+/* #if (defined(ENABLE_POSTGRESQL) && PACKAGE_VERSION >= 7.4) */
+	if (p->ip6h)
+	{
+	    char src[INET6_ADDRSTRLEN], dst[INET6_ADDRSTRLEN];
+
+	    inet_ntop(PF_INET6, &p->ip6h->ip6_src, src, INET6_ADDRSTRLEN);
+	    inet_ntop(PF_INET6, &p->ip6h->ip6_dst, dst, INET6_ADDRSTRLEN);
+
+            query = NewQueryNode(query, 0);
+
+            if(data->detail)
+            {
+
+		snprintf(query->val, MAX_QUERY_LENGTH, 
+			"INSERT INTO ip6hdr "
+                        "(sid, cid, ip6_src, ip6_dst, ip6_vfc,"
+                        "ip6_flow, ip6_plen, ip6_nxt, ip6_hlim) "
+                        "VALUES ('%u','%u','%s','%s','%u',"
+			"'%lu','%u','%u','%u')",
+			data->shared->sid, data->shared->cid, 
+			src, dst, p->ip6h->s_ip6_vfc,
+			(u_long)ntohl(p->ip6h->s_ip6_flow),
+			(u_short)ntohs(p->ip6h->s_ip6_plen),
+			p->ip6h->s_ip6_nxt, p->ip6h->s_ip6_hlim);
+	    }
+            else
+            {
+                snprintf(query->val, MAX_QUERY_LENGTH, 
+                        "INSERT INTO iphdr "
+                        "(sid, cid, ip6_src, ip6_dst, ip6_nxt) "
+                        "VALUES ('%u','%u','%s','%s','%u')",
+                        data->shared->sid, data->shared->cid,
+			src, dst, p->ip6h->s_ip6_nxt);
+            }
+	}
+/*#endif (defined(ENABLE_POSTGRESQL) && PACKAGE_VERSION >= 7.4) */
 
         /*** Build query for the payload ***/
         if ( p->data )
diff -ur snort-2.0.2/src/output-plugins/spo_database.h snort-2.0.2-ipv6/src/output-plugins/spo_database.h
--- snort-2.0.2/src/output-plugins/spo_database.h	Mon Apr  1 05:42:19 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_database.h	Tue Sep 30 13:25:26 2003
@@ -19,7 +19,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_database.h,v 1.15 2002/03/31 20:42:19 andrewbaker Exp $ */
+/* $Id: spo_database.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 #ifndef __SPO_DATABASE_H__
 #define __SPO_DATABASE_H__
diff -ur snort-2.0.2/src/output-plugins/spo_log_ascii.c snort-2.0.2-ipv6/src/output-plugins/spo_log_ascii.c
--- snort-2.0.2/src/output-plugins/spo_log_ascii.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_ascii.c	Sat Nov 29 16:37:01 2003
@@ -19,7 +19,7 @@
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
-/* $Id: spo_log_ascii.c,v 1.13 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_log_ascii.c,v 1.3 2003/11/29 07:37:01 abekatsu Exp $ */
 
 /* spo_log_ascii
  * 
@@ -117,6 +117,8 @@
     { 
         if(p->iph)
             log_ptr = OpenLogFile(0, p);
+	else if (p->ip6h) 
+            log_ptr = OpenLogFile(0, p); 
         else if(p->ah)
             log_ptr = OpenLogFile(ARP, p);
         else
@@ -138,6 +140,8 @@
     {
         if(p->iph)
             PrintIPPkt(log_ptr, p->iph->ip_proto, p);
+	else if (p->ip6h) 
+            PrintIP6Pkt(log_ptr, p->ip6h->s_ip6_nxt, p);
         else if(p->ah)
             PrintArpHeader(log_ptr, p);
     }
@@ -177,6 +181,7 @@
     char proto[5];      /* logged packet protocol */
     char suffix[5];     /* filename suffix */
     FILE *log_ptr = NULL;
+    u_int8_t protocol;
 #ifdef WIN32
     strcpy(suffix,".ids");
 #else
@@ -216,47 +221,63 @@
         }
     }
     /* figure out which way this packet is headed in relation to the homenet */
-    if((p->iph->ip_dst.s_addr & pv.netmask) == pv.homenet)
+    if (p->iph != NULL)
     {
-        if((p->iph->ip_src.s_addr & pv.netmask) != pv.homenet)
-        {
-            snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                    inet_ntoa(p->iph->ip_src));
-        }
-        else
-        {
-            if(p->sp >= p->dp)
-            {
-                snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                        inet_ntoa(p->iph->ip_src));
-            }
-            else
-            {
-                snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                        inet_ntoa(p->iph->ip_dst));
-            }
-        }
-    }
-    else
-    {
-        if((p->iph->ip_src.s_addr & pv.netmask) == pv.homenet)
-        {
-            snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                    inet_ntoa(p->iph->ip_dst));
-        }
-        else
-        {
-            if(p->sp >= p->dp)
-            {
-                snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                        inet_ntoa(p->iph->ip_src));
-            }
-            else
-            {
-                snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
-                        inet_ntoa(p->iph->ip_dst));
-            }
-        }
+	if((p->iph->ip_dst.s_addr & pv.netmask) == pv.homenet)
+	{
+	    if((p->iph->ip_src.s_addr & pv.netmask) != pv.homenet)
+	    {
+		snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			 inet_ntoa(p->iph->ip_src));
+	    }
+	    else
+	    {
+		if(p->sp >= p->dp)
+		{
+		    snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			     inet_ntoa(p->iph->ip_src));
+		}
+		else
+		{
+		    snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			     inet_ntoa(p->iph->ip_dst));
+		}
+	    }
+	}
+	else
+	{
+	    if((p->iph->ip_src.s_addr & pv.netmask) == pv.homenet)
+	    {
+		snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			 inet_ntoa(p->iph->ip_dst));
+	    }
+	    else
+	    {
+		if(p->sp >= p->dp)
+		{
+		    snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			     inet_ntoa(p->iph->ip_src));
+		}
+		else
+		{
+		    snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, 
+			     inet_ntoa(p->iph->ip_dst));
+		}
+	    }
+	}
+    }
+    else if (p->ip6h != NULL)
+    {
+	/* 
+	 * temporary 
+	 * It is necessary to edit the definition of pv.netmask and 
+	 * pv.homenet.
+	 */
+	char tmp[INET6_ADDRSTRLEN];
+
+	inet_ntop(PF_INET6, &p->ip6h->ip6_src, tmp, INET6_ADDRSTRLEN);
+	snprintf(log_path, STD_BUF, "%s/%s", pv.log_dir, tmp);
+
     }
 
     DEBUG_WRAP(DebugMessage(DEBUG_FLOW, "Creating directory: %s\n", log_path););
@@ -275,50 +296,63 @@
     DEBUG_WRAP(DebugMessage(DEBUG_FLOW, "Directory Created!\n"););
 
     /* build the log filename */
-    if(p->iph->ip_proto == IPPROTO_TCP ||
-            p->iph->ip_proto == IPPROTO_UDP)
+    if(p->iph != NULL)
     {
-        if(p->frag_flag)
-        {
-            snprintf(log_file, STD_BUF, "%s/IP_FRAG%s", log_path, suffix);
-        }
-        else
-        {
-            if(p->sp >= p->dp)
-            {
+	protocol = p->iph->ip_proto;
+    }
+    else if (p->ip6h != NULL)
+    {
+	protocol = p->ip6h->s_ip6_nxt;
+    }
+
+    if(protocol == IPPROTO_TCP || protocol == IPPROTO_UDP )
+    {
+	if(p->frag_flag)
+	{
+	    snprintf(log_file, STD_BUF, "%s/IP_FRAG%s", log_path, suffix);
+	}
+	else
+	{
+	    if(p->sp >= p->dp)
+	    {
 #ifdef WIN32
-                snprintf(log_file, STD_BUF, "%s/%s_%d-%d%s", log_path,
-                        protocol_names[p->iph->ip_proto], p->sp, p->dp, suffix);
+		snprintf(log_file, STD_BUF, "%s/%s_%d-%d%s", log_path,
+			 protocol_names[protocol], p->sp, p->dp, suffix);
 #else
-                snprintf(log_file, STD_BUF, "%s/%s:%d-%d%s", log_path,
-                        protocol_names[p->iph->ip_proto], p->sp, p->dp, suffix);
+		snprintf(log_file, STD_BUF, "%s/%s:%d-%d%s", log_path,
+			 protocol_names[protocol], p->sp, p->dp, suffix);
 #endif
-            }
-            else
-            {
+	    }
+	    else
+	    {
 #ifdef WIN32
-                snprintf(log_file, STD_BUF, "%s/%s_%d-%d%s", log_path,
-                        protocol_names[p->iph->ip_proto], p->dp, p->sp, suffix);
+		snprintf(log_file, STD_BUF, "%s/%s_%d-%d%s", log_path,
+			 protocol_names[protocol], p->dp, p->sp, suffix);
 #else
-                snprintf(log_file, STD_BUF, "%s/%s:%d-%d%s", log_path,
-                        protocol_names[p->iph->ip_proto], p->dp, p->sp, suffix);
+		snprintf(log_file, STD_BUF, "%s/%s:%d-%d%s", log_path,
+			 protocol_names[protocol], p->dp, p->sp, suffix);
 #endif
-            }
-        }
+	    }
+	}
     }
     else
     {
-        if(p->frag_flag)
-        {
-            snprintf(log_file, STD_BUF, "%s/IP_FRAG%s", log_path, suffix);
-        }
-        else
-        {
-            if(p->iph->ip_proto == IPPROTO_ICMP)
-            {
-                snprintf(log_file, STD_BUF, "%s/%s_%s%s", log_path, "ICMP",
-                         IcmpFileName(p), suffix);
+	if(p->frag_flag)
+	{
+	    snprintf(log_file, STD_BUF, "%s/IP_FRAG%s", log_path, suffix);
+	}
+	else
+	{
+	    if(protocol == IPPROTO_ICMP)
+	    {
+		snprintf(log_file, STD_BUF, "%s/%s_%s%s", log_path, "ICMP",
+			 IcmpFileName(p), suffix);
             }
+	    else if (protocol == IPPROTO_ICMPV6)
+	    {
+		snprintf(log_file, STD_BUF, "%s/%s_%s%s", log_path, "ICMP6",
+			 IcmpFileName(p), suffix);
+	    }
             else
             {
                 snprintf(log_file, STD_BUF, "%s/PROTO%d%s", log_path,
@@ -355,74 +389,75 @@
  ***************************************************************************/
 char *IcmpFileName(Packet * p)
 {
-    if(p->icmph == NULL)
+    if(p->icmph == NULL && p->icmp6h == NULL)
     {
         return "ICMP_TRUNC";
     }
 
-    switch(p->icmph->type)
+    if(p->icmph != NULL)
     {
+	switch(p->icmph->type)
+	{
         case ICMP_ECHOREPLY:
-            return "ECHO_REPLY";
+	    return "ECHO_REPLY";
 
         case ICMP_DEST_UNREACH:
-            switch(p->icmph->code)
+	    switch(p->icmph->code)
             {
-                case ICMP_NET_UNREACH:
-                    return "NET_UNRCH";
-
-                case ICMP_HOST_UNREACH:
-                    return "HST_UNRCH";
+	    case ICMP_NET_UNREACH:
+		return "NET_UNRCH";
 
-                case ICMP_PROT_UNREACH:
-                    return "PROTO_UNRCH";
+	    case ICMP_HOST_UNREACH:
+		return "HST_UNRCH";
 
-                case ICMP_PORT_UNREACH:
-                    return "PORT_UNRCH";
+	    case ICMP_PROT_UNREACH:
+		return "PROTO_UNRCH";
 
-                case ICMP_FRAG_NEEDED:
-                    return "UNRCH_FRAG_NEEDED";
+	    case ICMP_PORT_UNREACH:
+		return "PORT_UNRCH";
+		
+	    case ICMP_FRAG_NEEDED:
+		return "UNRCH_FRAG_NEEDED";
 
-                case ICMP_SR_FAILED:
-                    return "UNRCH_SOURCE_ROUTE_FAILED";
+	    case ICMP_SR_FAILED:
+		return "UNRCH_SOURCE_ROUTE_FAILED";
 
-                case ICMP_NET_UNKNOWN:
-                    return "UNRCH_NETWORK_UNKNOWN";
+	    case ICMP_NET_UNKNOWN:
+		return "UNRCH_NETWORK_UNKNOWN";
 
-                case ICMP_HOST_UNKNOWN:
-                    return "UNRCH_HOST_UNKNOWN";
+	    case ICMP_HOST_UNKNOWN:
+		return "UNRCH_HOST_UNKNOWN";
 
-                case ICMP_HOST_ISOLATED:
-                    return "UNRCH_HOST_ISOLATED";
+	    case ICMP_HOST_ISOLATED:
+		return "UNRCH_HOST_ISOLATED";
 
-                case ICMP_PKT_FILTERED_NET:
-                    return "UNRCH_PKT_FILTERED_NET";
+	    case ICMP_PKT_FILTERED_NET:
+		return "UNRCH_PKT_FILTERED_NET";
 
-                case ICMP_PKT_FILTERED_HOST:
-                    return "UNRCH_PKT_FILTERED_HOST";
+	    case ICMP_PKT_FILTERED_HOST:
+		return "UNRCH_PKT_FILTERED_HOST";
 
-                case ICMP_NET_UNR_TOS:
-                    return "UNRCH_NET_UNR_TOS";
+	    case ICMP_NET_UNR_TOS:
+		return "UNRCH_NET_UNR_TOS";
 
-                case ICMP_HOST_UNR_TOS:
-                    return "UNRCH_HOST_UNR_TOS";
+	    case ICMP_HOST_UNR_TOS:
+		return "UNRCH_HOST_UNR_TOS";
 
-                case ICMP_PKT_FILTERED:
-                    return "UNRCH_PACKET_FILT";
+	    case ICMP_PKT_FILTERED:
+		return "UNRCH_PACKET_FILT";
 
-                case ICMP_PREC_VIOLATION:
-                    return "UNRCH_PREC_VIOL";
+	    case ICMP_PREC_VIOLATION:
+		return "UNRCH_PREC_VIOL";
 
-                case ICMP_PREC_CUTOFF:
-                    return "UNRCH_PREC_CUTOFF";
-
-                default:
-                    return "UNKNOWN";
+	    case ICMP_PREC_CUTOFF:
+		return "UNRCH_PREC_CUTOFF";
 
+	    default:
+		return "UNKNOWN";
             }
 
         case ICMP_SOURCE_QUENCH:
-            return "SRC_QUENCH";
+	    return "SRC_QUENCH";
 
         case ICMP_REDIRECT:
             return "REDIRECT";
@@ -456,6 +491,64 @@
 
         default:
             return "UNKNOWN";
+	}
+    }
+    else if (p->icmp6h != NULL)
+    {
+	 switch(p->icmp6h->icmp6_type)
+	 {
+	 case ICMP6_DST_UNREACH:
+	     switch(p->icmp6h->icmp6_code)
+	     {
+	     default:
+		 return "DST_UNREACH_UNKNOWN_CODE";
+	     }
+	 case ICMP6_PACKET_TOO_BIG:
+	     return "PACKET_TOO_BIG";
+	 case ICMP6_TIME_EXCEEDED:
+	     switch(p->icmp6h->icmp6_code)
+	     {
+	     default:
+		 return "TIME_EXCEEDED_UNKNOWN_CODE";
+	     }
+	 case ICMP6_PARAM_PROB:
+	     switch(p->icmp6h->icmp6_code)
+	     {
+	     default:
+		 return "TIME_EXCEEDED_UNKNOWN_CODE";
+	     }
+	 case ICMP6_ECHO_REQUEST:
+	     return "ECHO_REQUEST";
+	 case ICMP6_ECHO_REPLY:
+	     return "ECHO_REPLY";
+	 case MLD_LISTENER_QUERY:
+	     return "MLD_LISTENER_QUERY";
+	 case MLD_LISTENER_REPORT:
+	     return "MLD_LISTENER_REPORT";
+	 case MLD_LISTENER_DONE:
+	     return "MLD_LISTENER_DONE";
+	 case ND_ROUTER_SOLICIT:
+	     return "ND_ROUTER_SOLICIT";
+	 case ND_ROUTER_ADVERT:
+	     return "ND_ROUTER_ADVERT";
+	 case ND_NEIGHBOR_SOLICIT:
+	     return "ND_NEIGHBOR_SOLICIT";
+	 case ND_NEIGHBOR_ADVERT:
+	     return "ND_NEIGHBOR_ADVERT";
+	 case ND_REDIRECT:
+	     return "ND_REDIRECT";
+	 case ICMP6_ROUTER_RENUMBERING:
+	     return "ROUTER_RENUMBERING";
+	 case ICMP6_NI_QUERY:
+	     return "NI_QUERY";
+	 case ICMP6_NI_REPLY:
+	     return "NI_REPLY";
+
+	     
+	 default:
+	     return "UNKNOWN";
+	 }
+	 
     }
 }
 
diff -ur snort-2.0.2/src/output-plugins/spo_log_ascii.h snort-2.0.2-ipv6/src/output-plugins/spo_log_ascii.h
--- snort-2.0.2/src/output-plugins/spo_log_ascii.h	Mon Jan  6 05:36:28 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_ascii.h	Tue Sep 30 13:25:26 2003
@@ -19,7 +19,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_log_ascii.h,v 1.2 2003/01/05 20:36:28 cazz Exp $ */
+/* $Id: spo_log_ascii.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 
 #ifndef __SPO_LOG_ASCII_H__
diff -ur snort-2.0.2/src/output-plugins/spo_log_null.c snort-2.0.2-ipv6/src/output-plugins/spo_log_null.c
--- snort-2.0.2/src/output-plugins/spo_log_null.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_null.c	Tue Sep 30 13:25:26 2003
@@ -15,7 +15,7 @@
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
-/* $Id: spo_log_null.c,v 1.8 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_log_null.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* spo_log_null
  * 
diff -ur snort-2.0.2/src/output-plugins/spo_log_null.h snort-2.0.2-ipv6/src/output-plugins/spo_log_null.h
--- snort-2.0.2/src/output-plugins/spo_log_null.h	Mon Apr  1 05:42:19 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_null.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_log_null.h,v 1.4 2002/03/31 20:42:19 andrewbaker Exp $ */
+/* $Id: spo_log_null.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 
 #ifndef __SPO_LOG_NULL_H__
diff -ur snort-2.0.2/src/output-plugins/spo_log_tcpdump.c snort-2.0.2-ipv6/src/output-plugins/spo_log_tcpdump.c
--- snort-2.0.2/src/output-plugins/spo_log_tcpdump.c	Tue May 20 03:08:05 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_tcpdump.c	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_log_tcpdump.c,v 1.34 2003/05/19 18:08:05 chrisgreen Exp $ */
+/* $Id: spo_log_tcpdump.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* spo_log_tcpdump 
  * 
